import { Node } from 'node-red'
export declare type CallbackType = {
    (message: string): void
}
export declare type Loggers = {
    debug: CallbackType
    error: (message: string, nodeError?: boolean, injectedNode?: Node) => void
    trace: CallbackType
}
export declare type LoggerSetupData = {
    debugColor?: string
    debugEnabled?: boolean
    errorColor?: string
    errorEnabled?: boolean
    traceColor?: string
    traceEnabled?: boolean
    timestampEnabled?: boolean | string
}
export declare type Logger = (
    namespacePrefix: string,
    namespace?: string,
    messagePrefix?: string,
    node?: Node
) => Loggers
